﻿using System;

namespace Playground
{
    internal static class Program
    {
        private static void Main()
        {
            Console.WriteLine("Small dependency injection example.");
            var injector = new SmallInjector();
            injector.RegisterType<ServiceOne, IServiceOne>(true);
            injector.RegisterType<ServiceTwo, IServiceTwo>(true);
            injector.RegisterType<UsefulClass>(false);

            Console.WriteLine();
            Console.WriteLine("Resolve class instances.");
            var useful1 = injector.Resolve<UsefulClass>();
            var useful2 = injector.Resolve<UsefulClass>();
            var useful3 = injector.Resolve<UsefulClass>();
            Console.WriteLine();
            Console.WriteLine("Run test methods.");
            useful1.TestTheServices();
            useful2.TestTheServices();
            useful3.TestTheServices();
            Console.ReadLine();
        }
    }
}